{
  Autor: Michael Springwald

  Datum: 23.04.2017
}

program pwiAPP2;

{$mode objfpc}{$H+}

uses
  cthreads,
  Classes, SysUtils, CustApp, Crt,
  WebSocket2, uplWebSocket
  ;

type
  { TPLWebInterface }

  TPLWebInterface = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    AppDir, AppName:String;
    constructor Create(TheOwner: TComponent);
    destructor Destroy; override;

  end;


{ TPLWebInterface }

procedure TPLWebInterface.DoRun;
var
  quit:boolean;

  noKeyPress:Boolean;

  str, host, WebPort:string;
  i,x:Integer;
begin
  Randomize;

  AppDir:=ExtractFileDir(ParamStr(0)) + DirectorySeparator;

  host:='10.10.10.10'; str:=''; noKeyPress:=true; quit:=false;

  if Paramcount > 0 then begin
    for i:=1 to Paramcount do begin
      str:=LowerCase(ParamStr(i));
      if str = 'nokeypress' then noKeyPress:=false;


      if str = 'host' then host:=ParamStr(i+1);
      if str = 'webport' then WebPort:=ParamStr(i+1);

      if str = 'help' then begin
        Quit:=true;
        Terminate;
        break;
      end;
    end; // for i
  end;

  if quit then exit;

  if WebPort <> '' then begin
    Server:=TPLWebSocketServer.Create;
    Server.Start(host, StrToInt(WebPort));
  end
  else
    Server:=nil;

  repeat

    if noKeyPress then begin
      if Keypressed then begin
        case readkey of
          #27: quit := true;
          '1': begin
            writeln('1');
          end;

          '2': begin
            writeln('2');
          end;

          '3': begin
            writeln('3');
          end;

          '4': begin
            writeln('4');
          end;

          '5': begin
            writeln('5');
          end;

          '6': begin
            writeln('6');
          end;

          '7': begin
            writeln('7');
          end;
        end;
      end;
    end;
    delay(1);
  until quit;
  if Assigned(Server) then FreeAndNil(Server);
  Terminate;
end;

constructor TPLWebInterface.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

destructor TPLWebInterface.Destroy;
begin
  inherited Destroy;
end;

var
  Application: TPLWebInterface;
begin
  Application:=TPLWebInterface.Create(nil);
  Application.Title:='Web Interface';
  Application.Run;
  Application.Free;
end.

